var FBInstant = {};
FBInstant.setLoadingProgress = function (progress) {
    console.log("FBInstant.setLoadingProgress:", progress);
}
FBInstant.initializeAsync = function () {
    console.log('FBInstant.initializeAsync');
    return new Promise(resolve => {
        setTimeout(resolve, 100);
    })
}
FBInstant.startGameAsync = function () {
    console.log('FBInstant.startGameAsync');
    return new Promise(resolve => {
        setTimeout(resolve, 100);
    })
};
FBInstant.getEntryPointAsync = function (entryPoint) {
    console.log('FBInstant.getEntryPointAsync');
    return new Promise(resolve => {
        setTimeout(() => {
            resolve({});
        }, 100);
    })
}

FBInstant.getEntryPointData = function () {
    return {};
};

//fb instant initialize  langue: platform:WEB sdk:7.1 fbid:6667721119953880 contextId:null contextType:SOLO
/*
  this.langue = p.getLocale(),
  this.platform = p.getPlatform(),
  this.sdkVersion = p.getSDKVersion(),

  this.playerId = p.player.getID(),
  this.playerName = p.player.getName(),
  this.playerIconUrl = p.player.getPhoto(),

  this.contextType = p.context.getType(),
  this.contextId = p.context.getID(),

  this.isBannerSupport = p.getSupportedAPIs().includes("loadBannerAdAsync"),
  this.isVedioSupport = p.getSupportedAPIs().includes("getRewardedVideoAsync"),
  this.isInterSupport = p.getSupportedAPIs().includes("getInterstitialAdAsync"),
  this.isInterRewardSupport = p.getSupportedAPIs().includes("getRewardedInterstitialAsync");
  var n = p.getEntryPointData();
*/
FBInstant.getLocale = function () {
    return '';
}
FBInstant.getPlatform = function () {
    return 'WEB'
}
FBInstant.getSDKVersion = function () {
    return '7.1'
}

FBInstant.getSignature = function () {
    return '7.1'
}


function randomPlayer() {
    const player = {};
    const now = Date.now();
    player.getID = function () {
        return now;
    }
    player.getName = function () {
        return 'player' + now
    }
    player.getPhoto = function () {
        return ''
    }
    player.setDataAsync = function (kv) {
        return new Promise(resolve => {
            for (let p in kv) {
                localStorage.setItem(p, JSON.stringify(kv[p]));
            }
            resolve();
        })
    }
    player.getDataAsync = function (keys) {
        return new Promise(resolve => {
            var data = {};
            for (var i = 0; i < keys.length; i++) {
                var c = localStorage.getItem(keys[i]);
                if (c)
                    data[keys[i]] = JSON.parse(c);
            }
            resolve({});
        })
    }
    player.getSignedASIDAsync = function () {
        return new Promise(resolve => {
            resolve({});
        })
    }
    player.canSubscribeBotAsync = function () {
        return new Promise(resolve => {
            resolve(true);
        })
    }
    return player;
}

FBInstant.player = randomPlayer();
// FBInstant.player.getID = function () { return '6667721119953880' }
// FBInstant.player.getName = function () { return 'player' }
// FBInstant.player.getPhoto = function () { return '' }

FBInstant.player.getConnectedPlayersAsync = function () {
    return new Promise(resolve => {
        resolve([randomPlayer(), randomPlayer()]);
    });
}

FBInstant.player.getSignedPlayerInfoAsync = function () {
    return new Promise(resolve => {
        resolve([randomPlayer(), randomPlayer()]);
    });
}

FBInstant.player.getDataAsync = function () {
    return new Promise(resolve => {
        resolve({});
    })
}

FBInstant.performHapticFeedbackAsync = function () {
};

FBInstant.context = {};
FBInstant.context.getType = function () {
    return 'SOLO'
}
FBInstant.context.getID = function () {
    return ''
}

FBInstant.getSupportedAPIs = function () {
    return [
        'loadBannerAdAsync',
        'getRewardedVideoAsync',
        'getInterstitialAdAsync',
        'getRewardedInterstitialAsync'
    ]
}

function createLoadAsync() {
    return {
        loadAsync: function () {
            return Promise.resolve();
        }
    }
}

FBInstant.loadBannerAdAsync = function () {
    console.log('FB:loadBannerAdAsync', arguments);
    return Promise.resolve(createLoadAsync());
}

FBInstant.getRewardedInterstitialAsync = function () {
    console.log('FB:getRewardedInterstitialAsync', arguments);
    return Promise.resolve(createLoadAsync());
}

FBInstant.getInterstitialAdAsync = function () {
    console.log('FB:getInterstitialAdAsync', arguments);
    return Promise.resolve(createLoadAsync());
}

FBInstant.getRewardedVideoAsync = function () {
    console.log('FB:getRewardedVideoAsync', arguments);
    return Promise.resolve(createLoadAsync());
}

FBInstant.onPause = function (cb) {
}

FBInstant.paymentEnable = false;

const obj = {
    getID: function () {
        return ''
    },
    getEndTime: function () {
        return 0
    }
}
FBInstant.getTournamentAsync = function () {
    return new Promise(resolve => {
        resolve(obj);
    });
}

FBInstant.community = {
    canFollowOfficialPageAsync: function () {
        return Promise.resolve(true);
    }
}

FBInstant.canCreateShortcutAsync = function () {
    return Promise.resolve(false);
}
